/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

var app = {
    // Application Constructor
    initialize: function() {
        document.addEventListener('deviceready', this.onDeviceReady.bind(this), false);
    },

    // deviceready Event Handler
    //
    // Bind any cordova events here. Common events are:
    // 'pause', 'resume', etc.
    onDeviceReady: function() {
        // $("#ServerIP").click(function (e){
        //   var socket = io(document.getElementById("ServerIP").value);
        //   console.log(document.getElementById("ServerIP").value);
        // })
        var socket = io('http://192.168.1.46:8080');
        socket.on('connect', function(){
          console.log('connected by cordova');
        })


        socket.on('entrees', function(value){
          for (var k in value) {
            var str = value[k];
            var res = str.replace(/\s/g, "_");
            $('#Entrees').append('<button type="button" class="btn btn-primary btn-lg" id="'+res+'">'+ str +'</button>');
          }
          $('#Entrees button').click(function (e){
            var id = e.target.id;
            var data = id.replace(/_/g, " ");
            socket.emit('entrees', data);
            socket.emit('commande');
          })
        })

        socket.on('plat', function(value){
          for (var k in value) {
            var str = value[k];
            var res = str.replace(/\s/g, "_");
            $('#Plat').append('<button type="button" class="btn btn-primary btn-lg" id="'+res+'">'+ str +'</button>');
          }
          $('#Plat button').click(function (e){
            var id = e.target.id;
            var data = id.replace(/_/g, " ");
            socket.emit('plat', data);
            socket.emit('commande');
          })
        })

        socket.on('dessert', function(value){
          for (var k in value) {
            var str = value[k];
            var res = str.replace(/\s/g, "_");
            $('#Dessert').append('<button type="button" class="btn btn-primary btn-lg" id="'+res+'">'+ str +'</button>');
          }
          $('#Dessert button').click(function (e){
            var id = e.target.id;
            var data = id.replace(/_/g, " ");
            socket.emit('dessert', data);
            socket.emit('commande');
          })
        })


        $('#numTable button').click(function (e){
          var table = e.target.id;
          socket.emit('tableSelectionner', table);
          $('#Commande li').remove();
          socket.emit('commande');
        })

        socket.on('commande', function (data) {
          $('#Commande li').remove();
          var itr;
          for (var i in data) {
            if(data[i]){
              itr = 0;
              for (var k in data){
                if(data[i] == data[k]){
                  itr += 1;
                }
              }
              var str = data[i];
              var res = str.replace(/\s/g, "_");
              var ress2 = res+'Commande';

              if(itr == 1){
                $('#Commande').append('<li id="'+ ress2 +'">'+ str +' <a href="#" id="'+ res +'">(delete)</a></li>');
              }else {
                $('#'+ress2).remove();
                $('#Commande').append('<li id="'+ ress2 +'">'+ str +' x'+ itr+' <a href="#" id="'+ res +'">(delete)</a></li>');
              }
          }
          }
          $('#Commande a').click(function (e){
            var id = e.target.id;
            var data = id.replace(/_/g, " ");
            socket.emit('deleteElement', data);
            socket.emit('commande');
          })
        })

        $('#valideCommande').click(function (e){
          socket.emit('listCommandeCuisine');
          $('#valideCommande').css("display", "none");
          $('#Carte').css("display", "none");
          $('#Entrees').css("display", "none");
          $('#Plat').css("display", "none");
          $('#Dessert').css("display", "none");
        })

        socket.on('listCommandeCuisine', function (data, nomTable) {
          $('#'+nomTable).remove();
          for (var i in data) {
            if(data[i]){
              $('#listCommandeCuisine').append('<ul id='+nomTable+'>'+nomTable+'</ul>');
              break;
            }
          }
          var itr;
          for (var i in data) {
            if(data[i]){
              itr = 0;
              for (var k in data){
                if(data[i] == data[k]){
                  itr += 1;
                }
              }
              var str = data[i];
              var res = str.replace(/\s/g, "_");
              var ress2 = res+'list';

              if(itr == 1){
                $('#'+nomTable).append('<li id="'+ ress2 +'">'+ str +'</li>');
              }else {
                $('#'+ress2).remove();
                $('#'+nomTable).append('<li id="'+ ress2 +'">'+ str +' x'+ itr+'</li>');
              }
          }
          }
        })

        var CoutTotal_t1 = 0;
        var CoutTotal_t2 = 0;
        var CoutTotal_t3 = 0;
        socket.on('soldCaisse' , function(Recette, Table){
          if (Table == 'Table_1') {
            $('#Caisse_t1').append('<li>'+ Recette.name+'/'+ Recette.Prix +'$</li>');
            CoutTotal_t1 += Recette.Prix;
            $('#CoutTotal_t1').remove();
            $('#Caisse_t1').append('<li id="CoutTotal_t1"> >> Total :'+ CoutTotal_t1 +'$</li>');

          }else if (Table == 'Table_2') {
            $('#Caisse_t2').append('<li>'+ Recette.name+'/'+ Recette.Prix +'$</li>');
            CoutTotal_t2 += Recette.Prix;
            $('#CoutTotal_t2').remove();
            $('#Caisse_t2').append('<li id="CoutTotal_t2"> >> Total :'+ CoutTotal_t2 +'$</li>');
          }else if (Table == 'Table_3') {
            $('#Caisse_t3').append('<li>'+ Recette.name+'/'+ Recette.Prix +'$</li>');
            CoutTotal_t3 += Recette.Prix;
            $('#CoutTotal_t3').remove();
            $('#Caisse_t3').append('<li id="CoutTotal_t3"> >>Total :'+ CoutTotal_t3 +'$</li>');

          }
        })

        // gestion de l'affichage
        $("#Acceuil button").click(function(e){
          $('#retourAcceuil').css("display","inline");
          $('#Acceuil').css("display", "none");
        })
        $("#retourAcceuil").click(function(e){
          $('#retourAcceuil').css("display","none");
          $('#Cuisine').css("display","none");
          $('#Caisse').css("display","none");
          $('#numTable').css("display", "none");
          $('#Table').css("display", "none");
          $('#Carte').css("display", "none");
          $('#Entrees').css("display", "none");
          $('#Plat').css("display", "none");
          $('#Dessert').css("display", "none");
          $('#Commande').css("display", "none");
          $('#menuCuisine').css("display", "none");
          $('#listCommandeCuisine').css("display", "none");
          $('#valideCommande').css("display", "none");
          $('#Acceuil').css("display", "inline");

        })

        $("#affichageCuisine").click(function(e){
          $('#menuCuisine').css("display", "inline");
          $('#listCommandeCuisine').css("display", "inline");
        })

        $("#affichageCaisse").click(function(e){
          $("#Caisse").css("display", "inline");
          socket.emit('soldCaisse');
        })



        $("#affichageService").click(function(e){
          //$('#Service').css("display", "inline");
          $('#numTable').css("display", "inline");
          // $('#Commande').css("display", "inline");
          // $('#valideCommande').css("display", "inline");
        })

        $("#numTable button").click(function(e){
          $('#Table').css("display", "inline");
          $('#valideCommande').css("display", "inline");
          $('#Commande').css("display", "inline");
          $('#Carte').css("display", "none");
          $('#Entrees').css("display", "none");
          $('#Plat').css("display", "none");
          $('#Dessert').css("display", "none");
        })

        $("#Table button").click(function(e){
          $('#Carte').css("display", "none");
          $('#Entrees').css("display", "none");
          $('#Plat').css("display", "none");
          $('#Dessert').css("display", "none");
        })

        $("#menuCarte").click(function(e){
          $('#Carte').css("display", "inline");
        })

        $("#Carte button").click(function(e){
          $('#Entrees').css("display", "none");
          $('#Plat').css("display", "none");
          $('#Dessert').css("display", "none");
        })

        $("#CarteEntrees").click(function(e){
          $('#Entrees').css("display", "inline");
        })
        $("#CartePlat").click(function(e){
          $('#Plat').css("display", "inline");
        })
        $("#CarteDessert").click(function(e){
          $('#Dessert').css("display", "inline");
        })

      }
    };
app.initialize();
