// Tout d'abbord on initialise notre application avec le framework Express
// et la bibliothèque http integrée à node.
var express = require('express');
var app = express();
var mongoose = require('mongoose');
var http = require('http').Server(app);
var io = require('socket.io')(http);

mongoose.connect('mongodb://localhost/minime');
var db = mongoose.connection;
db.on('error', console.error.bind(console, 'connection error:'));
db.once('open', function() {
  console.log('we are connected to mongodb');
  // we're connected!
});

var RecetteSchema = mongoose.Schema({
  name: String,
  type: String,
  Formules: [String],
  Prix: Number
});

var Recette = mongoose.model('Recette', RecetteSchema);
//
// //e pour l'entrees
// var e1 = new Recette({ name: 'Salade Gourmande', type: 'entrees', Formules: ['32'], Prix: 18 });
// var e2 = new Recette({ name: 'Mozzarella Burrata', type: 'entrees', Formules: ['32'], Prix: 18 });
// var e3 = new Recette({ name: 'Salade Crevette', type: 'entrees', Formules: ['32'], Prix: 18 });
//
// e1.save(function (err, e1) {
//     if (err) return console.error(err);
//   });
// e2.save(function (err, e2) {
//     if (err) return console.error(err);
//   });
// e3.save(function (err, e3) {
//     if (err) return console.error(err);
//   });
//
// // p pour le plat
// var p1 = new Recette({ name: 'Chiffonade entrecote', type: 'plat', Formules: ['32'], Prix: 18 });
// var p2 = new Recette({ name: 'Côtelettes d’agneau', type: 'plat', Formules: ['32'], Prix: 1 });
// var p3 = new Recette({ name: 'Dos de cabillaud', type: 'plat', Formules: ['32'], Prix: 1 });
//
// p1.save(function (err, p1) {
//     if (err) return console.error(err);
//   });
// p2.save(function (err, p2) {
//     if (err) return console.error(err);
//   });
// p3.save(function (err, p3) {
//     if (err) return console.error(err);
//   });
//
// // d pour dessert
// var d1 = new Recette({ name: 'Dome chocolat', type: 'dessert', Formules: ['32'], Prix: 1 });
// var d2 = new Recette({ name: 'Nougat glacé aux pistaches', type: 'dessert', Formules: ['32'], Prix: 1 });
// var d3 = new Recette({ name: 'Paris-Brest', type: 'dessert', Formules: ['32'], Prix: 1 });
//
// d1.save(function (err, d1) {
//     if (err) return console.error(err);
//   });
// d2.save(function (err, d2) {
//     if (err) return console.error(err);
//   });
// d3.save(function (err, d3) {
//     if (err) return console.error(err);
//   });

var entrees = {};
var plat = {};
var dessert = {};

var tableSelectionner;
var Table = {t1:[], t2:[], t3:[]};



Recette.find({type:/entrees/}, function (err, Recettes) {
    if (err) return console.error(err);
    for (var i = 0; i < Recettes.length; i++) {
      if (!(Recettes[i].name in entrees)) {
        entrees[Recettes[i].name] = Recettes[i].name ;
      }
    }
  });
Recette.find({type:/plat/}, function (err, Recettes) {
    if (err) return console.error(err);
    for (var i = 0; i < Recettes.length; i++) {
      if (!(Recettes[i].name in plat)) {
        plat[Recettes[i].name] = Recettes[i].name ;
      }
    }
  });
Recette.find({type:/dessert/}, function (err, Recettes) {
    if (err) return console.error(err);
    for (var i = 0; i < Recettes.length; i++) {
      if (!(Recettes[i].name in dessert)) {
        dessert[Recettes[i].name] = Recettes[i].name ;
      }
    }
  });


// On gère les requêtes HTTP des utilisateurs en leur renvoyant les fichiers du dossier 'public'
app.use("/", express.static(__dirname + "/public"));

// On lance le serveur en écoutant les connexions arrivant sur le port 8080
http.listen(8080, function(){
  console.log('Server is listening on *:8080');
});


io.on('connection', function(socket){
  console.log('user connected');

//gestion des entrees
  socket.emit('entrees', entrees);
  socket.on('entrees', function(value){
    if (tableSelectionner == 't1') {
      Table.t1.push(value);
    }else if (tableSelectionner == 't2') {
      Table.t2.push(value);
    }else if (tableSelectionner == 't3') {
      Table.t3.push(value);
    }
  })

//gestion des plats
  socket.emit('plat', plat);
  socket.on('plat', function(value){
    if (tableSelectionner == 't1') {
      Table.t1.push(value);
    }else if (tableSelectionner == 't2') {
      Table.t2.push(value);
    }else if (tableSelectionner == 't3') {
      Table.t3.push(value);
    }
  })

//gestion des dessert
  socket.emit('dessert', dessert);
  socket.on('dessert', function(value){
    if (tableSelectionner == 't1') {
      Table.t1.push(value);
    }else if (tableSelectionner == 't2') {
      Table.t2.push(value);
    }else if (tableSelectionner == 't3') {
      Table.t3.push(value);
    }
  })

// gestion des tables
  socket.on('tableSelectionner', function(table) {
    tableSelectionner = table;
  })

  socket.on('commande', function () {
    // mise en place visuel commande
    if (tableSelectionner == 't1') {
        socket.emit('commande', Table.t1);
    }else if (tableSelectionner == 't2') {
      socket.emit('commande', Table.t2);
    }else if (tableSelectionner == 't3') {
      socket.emit('commande', Table.t3);
    }
  })

  socket.on('deleteElement', function(element){
    if (tableSelectionner == 't1') {
      for(var k in Table.t1){
          if(Table.t1[k] == element){
            //console.log(Table.t1[k]);
            delete Table.t1[k];
            break;
          }
      }
    }
    else if (tableSelectionner == 't2') {
      for(var k in Table.t2){
          if(Table.t2[k] == element){
            //console.log(Table.t1[k]);
            delete Table.t2[k];
            break;
          }
      }
    }else if (tableSelectionner == 't3') {
      for(var k in Table.t3){
          if(Table.t3[k] == element){
            //console.log(Table.t1[k]);
            delete Table.t3[k];
            break;
          }
      }
    }
  })

  socket.on('listCommandeCuisine', function () {
    // mise en place visuel commande
    if (tableSelectionner == 't1') {
        socket.emit('listCommandeCuisine', Table.t1, 'Table_1');
    }else if (tableSelectionner == 't2') {
      socket.emit('listCommandeCuisine', Table.t2, 'Table_2');
    }else if (tableSelectionner == 't3') {
      socket.emit('listCommandeCuisine', Table.t3, 'Table_3');
    }
  })

  socket.on('soldCaisse', function(){
    for (var i in Table.t1) {
      Recette.findOne({name: Table.t1[i]}, function (err, Recette){
        socket.emit('soldCaisse', Recette, 'Table_1');
      })
    }
    for (var i in Table.t2) {
      Recette.findOne({name: Table.t2[i]}, function (err, Recette){
        socket.emit('soldCaisse', Recette, 'Table_2');
      })
    }
    for (var i in Table.t3) {
      Recette.findOne({name: Table.t3[i]}, function (err, Recette){
        socket.emit('soldCaisse', Recette, 'Table_3');
      })
    }
  });

});
